#pragma once

#include "ofxPoint2f.h"
#include "ofMain.h"

#include "arFakeMarker.h"
#include "coordWarping.h"

class arPlane : public arFakeMarker{

	public:
		
		//------------------------------------
		void calculateCoordinateTranslation(){
			dst[0] = ofPoint(-halfSize.x,  halfSize.y);
			dst[1] = ofPoint(halfSize.x,   halfSize.y);
			dst[2] = ofPoint(halfSize.x,  -halfSize.y);
			dst[3] = ofPoint(-halfSize.x, -halfSize.y);
		
//			printf("\n\ncalculating matrix\n\n");
//				for(int i = 0; i < 4; i++){
//					printf("src[%i] (%f, %f)\n", i, src[i].x, src[i].y);
//				}
//				for(int i = 0; i < 4; i++){
//					printf("dst[%i] (%f, %f)\n", i, dst[i].x, dst[i].y);
//				}
//			
//			printf("\n\n");
		
			CW.calculateMatrix(src, dst);
		}
		
		//------------------------------------		
		void setMarkerPoints(ofPoint p1, ofPoint p2, ofPoint p3, ofPoint p4){
			src[0] = p1;
			src[1] = p2;
			src[2] = p3;
			src[3] = p4;
			
			arFakeMarker::setMarkerPoints(src[0], src[1], src[2], src[3]);				
			calculateCoordinateTranslation();
		}
		
		//------------------------------------
		void setMarkerSize(int mm){
			arFakeMarker::setMarkerSize(mm);
			calculateCoordinateTranslation();
		}		

		//------------------------------------		
		ofPoint screenToMarker(float & xIn, float & yIn){
			return CW.transform(xIn, yIn);
		}
		
		//------------------------------------		
		ofPoint screenToMarker(ofxPoint2f & pt){
			return CW.transform(pt.x, pt.y);
		}

		//------------------------------------		
		ofPoint screenToMarker(ofPoint & pt){
			return CW.transform(pt.x, pt.y);
		}

		coordWarping CW;
		
		ofxPoint2f src[4];
		ofxPoint2f dst[4];		
		
};
	
		
